package su.a71.new_soviet.datagen;
// === ABANDON HOPE, YE WHO ENTER HERE ===

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.block.Block;
import net.minecraft.data.client.BlockStateModelGenerator;
import net.minecraft.data.client.ItemModelGenerator;
import net.minecraft.data.client.Models;
import net.minecraft.data.client.TextureMap;
import net.minecraft.registry.Registries;
import net.minecraft.util.Identifier;
import su.a71.new_soviet.registration.NSE_Blocks;

public class ModelGenerator extends FabricModelProvider {
    public ModelGenerator(FabricDataOutput generator) {
        super(generator);
    }

    // Helper method since "normal" registerDoor doesn't account for non-flat texture dir
    public void registerDoor(BlockStateModelGenerator blockStateModelGenerator, Block doorBlock) {
        TextureMap textureMap = TextureMap.topBottom(
                Registries.BLOCK.getId(doorBlock).withPath((path) -> "block/doors/" + path + "_top"),
                Registries.BLOCK.getId(doorBlock).withPath((path) -> "block/doors/" + path + "_bottom"));
        Identifier identifier = Models.DOOR_BOTTOM_LEFT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier2 = Models.DOOR_BOTTOM_LEFT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier3 = Models.DOOR_BOTTOM_RIGHT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier4 = Models.DOOR_BOTTOM_RIGHT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier5 = Models.DOOR_TOP_LEFT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier6 = Models.DOOR_TOP_LEFT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier7 = Models.DOOR_TOP_RIGHT.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        Identifier identifier8 = Models.DOOR_TOP_RIGHT_OPEN.upload(doorBlock, textureMap, blockStateModelGenerator.modelCollector);
        blockStateModelGenerator.registerItemModel(doorBlock.asItem());
        blockStateModelGenerator.blockStateCollector.accept(BlockStateModelGenerator.createDoorBlockState(doorBlock, identifier, identifier2, identifier3, identifier4, identifier5, identifier6, identifier7, identifier8));
    }

    @Override
    public void generateBlockStateModels(BlockStateModelGenerator blockStateModelGenerator) {
//            BlockStateModelGenerator.createSingletonBlockState(NSE_Blocks.SAND_TILES, new Identifier("new_soviet", "block/sand_tiles"));
//            BlockStateModelGenerator.createSlabBlockState()
//            BlockStateModelGenerator.createWallBlockState()
//            BlockStateModelGenerator.createStairsBlockState(NSE_Blocks.SAND_TILES_STAIRS, new Identifier(NewSoviet.MOD_ID, "sand_tiles_stairs"));
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_BIRCH_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_SPRUCE_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_OAK_DOOR);
        registerDoor(blockStateModelGenerator, NSE_Blocks.CHISELED_MANGROVE_DOOR);

//            blockStateModelGenerator.register();
    }

    @Override
    public void generateItemModels(ItemModelGenerator itemModelGenerator) {
    }
}
